#include <iostream>
#include <fstream>
#include <sstream>
#include <iomanip>
#include <cstdlib>
#include <cstdio>
#include <bitset>
#include <string>
#include <vector>
#include <deque>
#include <queue>
#include <stack>
#include <map>
#include <set>
#include <algorithm>
#include <numeric>
#include <cmath>

int main() {
    std::ios::sync_with_stdio(false);
    std::cin.tie(nullptr);

    int n, q;
    std::cin >> n >> q;
    std::vector<int> arr(n);
    for (int& elem : arr) {
        std::cin >> elem;
    }
    bool change = false;
    while (q--) {
        int t;
        std::cin >> t;
        if (t == 2) {
            int x;
            std::cin >> x;
            if (arr[x - 1] == 1) {
                std::cout << x << '\n';
            } else {
                std::cout << 2 << '\n';
            }
        } else {
            int x;
            std::cin >> x;
            std::swap(arr[x - 1], arr[x]);
        }
    }
    return 0;
}